import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkOrderInfo, ThinkOrderInfoParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkOrderInfo(params: ThinkOrderInfoParam) {
  const res = await request.get<ApiResult<PageResult<ThinkOrderInfo>>>(
    THINK_API_URL + '/think/think-order-info/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkOrderInfo(params?: ThinkOrderInfoParam) {
  const res = await request.get<ApiResult<ThinkOrderInfo[]>>(
    THINK_API_URL + '/think/think-order-info',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkOrderInfo(data: ThinkOrderInfo) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkOrderInfo(data: ThinkOrderInfo) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkOrderInfo(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkOrderInfo(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-order-info/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkOrderInfo(id: number) {
  const res = await request.get<ApiResult<ThinkOrderInfo>>(
    THINK_API_URL + '/think/think-order-info/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
